"""
@author Kuba
Django settings for api project.

Generated by 'django-admin startproject' using Django 2.2.16.

For more information on this file, see
https://docs.djangoproject.com/en/2.2/topics/settings/

For the full list of settings and their values, see
https://docs.djangoproject.com/en/2.2/ref/settings/
"""

import os
import sentry_sdk
from sentry_sdk.integrations.django import DjangoIntegration

# check if build will be run as deploy version
__deploy = os.environ.get('DJANGO_DEPLOY_VARIABLE', '')

# sentry.io
sentry_sdk.init(
    dsn="https://b04f6fbe701d4bb697467232659007fc@o1043368.ingest.sentry.io/6012917",
    integrations=[DjangoIntegration()],

    # Set traces_sample_rate to 1.0 to capture 100%
    # of transactions for performance monitoring.
    # We recommend adjusting this value in production.
    traces_sample_rate=1.0,

    # If you wish to associate users to errors (assuming you are using
    # django.contrib.auth) you may enable sending PII data.
    send_default_pii=True
)

# Build paths inside the project like this: os.path.join(BASE_DIR, ...)
BASE_DIR = os.path.dirname(os.path.dirname(os.path.abspath(__file__)))

# Quick-start development settings - unsuitable for production
# See https://docs.djangoproject.com/en/2.2/howto/deployment/checklist/
WSGI_APPLICATION = 'api.wsgi.application'
# SECURITY WARNING: keep the secret key used in production secret!
SECRET_KEY = 'r7v%yjute83dlkpf2=!u-_tv!j(((f1=q3a52(xg0-vqyef=t!'

# SECURITY WARNING: don't run with debug turned on in production!

if __deploy == "deploy":
    print("[Settings.py] -> DEBUG = FALSE")
    DEBUG = False
else:
    print("[Settings.py] -> DEBUG = TRUE")
    DEBUG = True
DEBUG = True

ALLOWED_HOSTS = ['photo-app-editor.herokuapp.com', '0.0.0.0', '127.0.0.1', 'localhost']

# Application definition

INSTALLED_APPS = [
    'django.contrib.admin',
    'django.contrib.auth',
    'django.contrib.contenttypes',
    'django.contrib.sessions',
    'django.contrib.messages',
    'django.contrib.staticfiles',
    'rest_framework',
    'api_core',
    'drf_yasg',
    'django_extensions',
    # Uncomment the next line to enable admin documentation:
    'django.contrib.admindocs'
]

MIDDLEWARE = [
    'django.middleware.security.SecurityMiddleware',
    'django.contrib.sessions.middleware.SessionMiddleware',
    'django.middleware.common.CommonMiddleware',
    'django.middleware.csrf.CsrfViewMiddleware',
    'django.contrib.auth.middleware.AuthenticationMiddleware',
    'django.contrib.messages.middleware.MessageMiddleware',
    'django.middleware.clickjacking.XFrameOptionsMiddleware',
]

ROOT_URLCONF = 'api.urls'

TEMPLATE_DIRS = [
    os.path.join(os.path.realpath(os.path.dirname(__file__)), 'templates/'),
]

TEMPLATES = [
    {
        'BACKEND': 'django.template.backends.django.DjangoTemplates',
        'DIRS': ['templates/'],
        'APP_DIRS': True,
        'OPTIONS': {
            'context_processors': [
                'django.template.context_processors.debug',
                'django.template.context_processors.request',
                'django.contrib.auth.context_processors.auth',
                'django.contrib.messages.context_processors.messages',
            ],
        },
    },
]

# Database status
# https://data.heroku.com/datastores/816baf3b-cb3a-44ff-b5a5-1dfda3e25a2a#

if __deploy == "deploy":
    print("[Settings.py] -> Loading deployment database...")
    DATABASES = {
        'default': {
            'ENGINE': 'django.db.backends.postgresql',
            'NAME': 'dbu087u4d7vkq5',
            'HOST': 'ec2-23-22-243-103.compute-1.amazonaws.com',
            'PORT': 5432,
            'USER': 'glmxieywnvmkmb',
            'PASSWORD': '4a5d249f5c449c1334b4491956788a965700db2f8315f00bd734b68761be3f37'
        }
    }
else:
    print("[Settings.py] -> Loading testing database...")
    DATABASES = {
        'default': {
            'ENGINE': 'django.db.backends.sqlite3',
            'NAME': os.path.join(BASE_DIR, 'db.sqlite3'),
        }
    }

# Password validation
# https://docs.djangoproject.com/en/2.2/ref/settings/#auth-password-validators

AUTH_PASSWORD_VALIDATORS = [
    {
        'NAME': 'django.contrib.auth.password_validation.UserAttributeSimilarityValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.MinimumLengthValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.CommonPasswordValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.NumericPasswordValidator',
    },
]

REST_FRAMEWORK = {
    'TEST_REQUEST_DEFAULT_FORMAT': 'json'
}

# Internationalization
# https://docs.djangoproject.com/en/2.2/topics/i18n/

LANGUAGE_CODE = 'en-us'

TIME_ZONE = 'Europe/Prague'

USE_I18N = True

USE_L10N = True

USE_TZ = True

# DEPLOYMENT

# BASE_DIR = os.path.dirname(os.path.dirname(os.path.abspath(__file__)))

# Static files (CSS, JavaScript, Images)
# https://docs.djangoproject.com/en/1.9/howto/static-files/
STATIC_ROOT = 'staticfiles'
STATIC_URL = '/static/'

DEFAULT_STORAGE = 'local'
